package metrics

import (
	"net"
	"testing"
)

func acceptConn(addr string) net.Conn {
	ln, _ := net.Listen("tcp", addr)
	conn, _ := ln.Accept()
	return conn
}

func TestStatsite_Flatten(t *testing.T) {
	s := &StatsiteSink{}
	flat := s.flattenKey([]string{"a", "b", "c", "d"})
	if flat != "a.b.c.d" {
		t.Fatalf("Bad flat")
	}
}

func TestStatsite_PushFullQueue(t *testing.T) {
	q := make(chan string, 1)
	q <- "full"

	s := &StatsiteSink{metricQueue: q}
	s.pushMetric("omit")

	out := <-q
	if out != "full" {
		t.Fatalf("bad val %v", out)
	}

	select {
	case v := <-q:
		t.Fatalf("bad val %v", v)
	default:
	}
}
